/*
 *      Mdulo............: CLIENTS.PRG
 *      Utilidad..........: Programa bsico para el mantenimiento de una DBF
 *                          de clientes. 
 *
 *      Ultima revisin...: 01-03-1996
 *
 *      Copyright (c) 1995, 96 por Gabriel Muoz Mrquez
 *      Todos los derechos reservados
 */

#include "ogl.ch"
#include "inkey.ch"

#define DB_BUSCAR .T.

FUNCTION Main()

   SET DATE TO FRENCH              // Fecha del pas

   // Si no existe el fichero ndice lo creamos

   if !File( "CLIENTES.NTX" )
      DbUseArea( .t.,, "Clientes" )   
      DbCreateIndex( "Clientes", "Upper( NOMBRE + APELLIDOS )", ;
	 { || Upper( _FIELD->NOMBRE + _FIELD->APELLIDOS ) } )        
      DBCloseArea()
   endif

   DbUseArea( .t.,, "Clientes" )
   DBSetIndex( "Clientes" )
   
   INIT GRAPHICS PATH "C:\CLIPPER5\OGL"

   ACTIVATE VerMenu()              // Ejecutamos el men
   DbCloseArea()                   // Cerramos DBF
   
   CLOSE GRAPHICS NOFADE
   
return( nil )

/* ==== FUNCION ESTATICA VerMenu()
 *      Muestra el men de la aplicacin
 */
STATIC FUNCTION VerMenu()

   DEFINE PULLDOWN oMenu WELCOME { || ;
      MESSAGEBOX "Object Clients;;Versin 1.0;;" + ;
	 "(c) Gabriel Muoz Mrquez, 1996" TITLE "Acerca de..." } ;
      TITLE "Object Clients v1.0"

      MENU "" MESSAGE "Informacin general"
	 MENUITEM "Informacin     F12" MESSAGE "Informacin sobre la DBF" ;
	    SHORTKEY K_F12 EXECUTE Info()
	 MENUITEM SEPARATOR
	 MENUITEM "Acerca de..." MESSAGE "Acerca del programa" EXECUTE ;
	    MESSAGEBOX "Object Clients;;Versin 1.0;;" + ;
		"(c) Gabriel Muoz Mrquez, 1996" TITLE "Acerca de..." 
      ENDMENU
      MENU "Clientes" MESSAGE "Operaciones de clientes: altas, bajas, modificaciones,..."
	 MENUITEM "Altas" MESSAGE "Introducir un nuevo cliente" EXECUTE Altas()
	 MENUITEM "Bajas" MESSAGE "Borrar un cliente de la DBF" EXECUTE Bajas("Borrar un cliente")
	 MENUITEM "Modificar" MESSAGE "Modificar un determinado cliente" EXECUTE VerRegistro( "Registro actual", .F. )
      ENDMENU
      MENU "Salida" MESSAGE "Salida del programa"
	 MENUITEM "Salir    Alt-X" MESSAGE "Salir al DOS" SHORTKEY K_ALT_X ;
	    EXECUTE oMenu:lEnd := .T.
      ENDMENU
   ENDPULLDOWN
   
return( oMenu )   

/* ==== FUNCION ESTATICA Altas()
 *      Aade un registro a la base de datos
 */
STATIC FUNCTION Altas()
   
   LOCAL oDialog
   LOCAL nCodiClient := LastRec() + 1, ;
	 nPesetas
   LOCAL cEmpresa, ;
	 cNombre, ;
	 cApellidos, ;
	 cDireccion, ;
	 cPoblacion, ;
	 cCP, ;
	 cProvincia, ;
	 cFechaEnvio := DToC( Date() ), ;
	 cPrograma
   LOCAL aCheck
   LOCAL lAceptar    := .F.
	 
   DEFINE DIALOG oDialog FROM 32,48 TO 436,600 TITLE "Alta de cliente" 
      
   @  15, 17 GETNUM nCodiClient ; 
      WIDTH 7 ;
      LEN   5 ;
      TITLE "Cod. Cliente" ;
      OF oDialog

   @  45, 17 GET cEmpresa ;
      WIDTH 27 ;
      LEN   25 ;
      TITLE "Empresa  " ;
      OF oDialog

   @  75, 17 GET cNombre ; 
      WIDTH 17 ;
      LEN   15 ;
      TITLE "Nombre   " ;
      OF oDialog
   
   @ 105, 17 GET cApellidos ; 
      WIDTH 32 ;
      LEN   30 ;
      TITLE "Apellidos" ;
      OF oDialog

   @ 135, 17 GET cDireccion ; 
      WIDTH 52 ;
      LEN   50 ;
      TITLE "Direccin" ;
      OF oDialog

   @ 165, 17 GET cPoblacion ; 
      WIDTH 52 ;
      LEN   50 ;
      TITLE "Poblacin" ;
      OF oDialog

   @ 195, 17 GET cCP ;
      WIDTH 7 ;
      LEN   5 ;
      TITLE "CP" ;
      VALID IsNumeric( cCP ) ;
      OF oDialog

   @ 195,135 GET cProvincia ; 
      WIDTH 32 ;
      LEN   30 ;
      TITLE "Provincia" ;
      OF oDialog

   @ 245, 17 GET cFechaEnvio ;
      WIDTH 10 ;
      LEN   8 ;
      TITLE "Fecha de envo" ;
      VALID IsFecha( cFechaEnvio ) ;
      OF oDialog

   @ 245,240 GET cPrograma ;
      WIDTH 26 ;
      LEN   30 ;
      TITLE "Programa" ;
      OF oDialog

   @ 275, 17 GETNUM nPesetas ;
      WIDTH 6 ;
      LEN   4 ;
      TITLE "Pts" ;
      OF oDialog
      
   @ 285, 305 SAY "Marque la casilla si se ha cobrado" OF oDialog

   @ 302, 345 BOX3D SIZE 30, 100 OF oDialog   

   @ 310,357 CHECKBOX aCheck ;
      ITEMS {"Cobrado"} ;
      OF oDialog
      
   @ 335, 90 BUTTON "Aceptar" ;
      SIZE 20, 65 ;
      EXECUTE lAceptar := .T., oDialog:lEnd := .T. ;
      OF oDialog

   @ 335,200 BUTTON "Cancelar" ;
      SIZE 20, 65 ;
      EXECUTE lAceptar := .F., oDialog:lEnd := .T. ;
      OF oDialog
      
   ACTIVATE oDialog
   
   if lAceptar
      DbAppend()
      REPLACE CODICLIENT WITH PadL( nCodiClient, 5, "0" )
      REPLACE EMPRESA    WITH cEmpresa
      REPLACE NOMBRE     WITH cNombre
      REPLACE APELLIDOS  WITH cApellidos
      REPLACE DIRECCION  WITH cDireccion
      REPLACE POBLACION  WITH cPoblacion
      REPLACE CP         WITH PadL( cCP, 5, "0" )
      REPLACE PROVINCIA  WITH cProvincia
      REPLACE FECHAENVIO WITH CToD( cFechaEnvio )
      REPLACE PROGRAMA   WITH cPrograma
      REPLACE PTS        WITH nPesetas
      REPLACE COBRADO    WITH aCheck[ 1 ]
   endif
   
return( nil )
      
/* ==== FUNCION ESTATICA Bajas()
 *      Borra un determinado registro
 */
STATIC FUNCTION Bajas( cTitle, lModo, aCampos )

   LOCAL cSeek, ;
	 cApellidos, ;
	 cNombre
   LOCAL nReg     := Recno()
   LOCAL oDialog
   LOCAL aCheck
   LOCAL lAceptar := .F.

   DEFINE DIALOG oDialog FROM 100,120 TO 330,510 TITLE cTitle

   @  30, 17 GET cApellidos ;
      WIDTH 32 ;
      LEN   30 ;
      TITLE "Apellidos" ;
      OF oDialog

   @  60, 17 GET cNombre ;
      WIDTH 17 ;
      LEN   15 ;
      TITLE "Nombre   " ;
      OF oDialog

   @ 116, 10 BOX3D SIZE 34, 357 OF oDialog

   @ 100, 17 SAY "Opciones" OF oDialog

   @ 125, 17 CHECKBOX aCheck ;
      ITEMS {"Bsqueda aproximada por nombre"} ;
      OF oDialog

   @ 170, 100 BUTTON "Aceptar" ;
      SIZE 20, 65 ;
      EXECUTE lAceptar := .T., oDialog:lEnd := .T. ;
      OF oDialog

   @ 170,210 BUTTON "Cancelar" ;
      SIZE 20, 65 ;
      EXECUTE lAceptar := .F., oDialog:lEnd := .T. ;
      OF oDialog

   ACTIVATE oDialog

   if lAceptar
      cSeek := if( aCheck[ 1 ], Alltrim( Upper( cNombre ) ), ;
	Upper( PadR( cNombre, 15 ) + PadR( cApellidos, 30 ) ) ) 

      if DbSeek( cSeek )
	 if lModo == NIL .or. !lModo
	    if VerRegistro( "Borrar ste cliente?", .T. )
	       DbDelete()
	       PACK
	    endif
	 else
	    NewReg( aCampos )
	 endif
      else
	 DbGoTo( nReg )
	 MESSAGEBOX "El cliente no existe"
      endif
   endif
   
return( nil )
	 
/* ==== FUNCION ESTATICA VerRegistro()
 *      Muestra el registro actual
 */
STATIC FUNCTION VerRegistro( cTitle, lBorrar )      
      
   LOCAL oDialog
   LOCAL nCodiClient := Val( _FIELD->CODICLIENT ), ;
	 nPesetas    := _FIELD->PTS
   LOCAL cEmpresa    := Alltrim( _FIELD->EMPRESA ),;
	 cNombre     := Alltrim( _FIELD->NOMBRE ), ; 
	 cApellidos  := Alltrim( _FIELD->APELLIDOS ), ;
	 cDireccion  := Alltrim( _FIELD->DIRECCION ), ;
	 cPoblacion  := Alltrim( _FIELD->POBLACION ), ;
	 cCP         := Alltrim( _FIELD->CP ), ;
	 cProvincia  := Alltrim( _FIELD->PROVINCIA ), ;
	 cFechaEnvio := DToC( _FIELD->FECHAENVIO ), ;
	 cPrograma   := Alltrim( _FIELD->PROGRAMA )
   LOCAL aCheck      
   LOCAL lAceptar    := .F.
	 
   DEFINE DIALOG oDialog FROM 32,48 TO 436,600 TITLE cTitle

   @  15, 17 GETNUM nCodiClient ; 
      WIDTH 7 ;
      LEN   5 ;
      TITLE "Cod. Cliente" ;
      ID 101 ;
      OF oDialog

   @  45, 17 GET cEmpresa ;
      WIDTH 27 ;
      LEN   25 ;
      TITLE "Empresa  " ;
      ID 102 ;
      OF oDialog

   @  75, 17 GET cNombre ; 
      WIDTH 17 ;
      LEN   15 ;
      TITLE "Nombre   " ;
      ID 103 ;
      OF oDialog
   
   @ 105, 17 GET cApellidos ; 
      WIDTH 32 ;
      LEN   30 ;
      TITLE "Apellidos" ;
      ID 104 ;
      OF oDialog

   @ 135, 17 GET cDireccion ; 
      WIDTH 52 ;
      LEN   50 ;
      TITLE "Direccin" ;
      ID 105 ;
      OF oDialog

   @ 165, 17 GET cPoblacion ; 
      WIDTH 52 ;
      LEN   50 ;
      TITLE "Poblacin" ;
      ID 106 ;
      OF oDialog

   @ 195, 17 GET cCP ;
      WIDTH 7 ;
      LEN   5 ;
      TITLE "CP" ;
      VALID IsNumeric( cCP ) ;
      ID 107 ;
      OF oDialog

   @ 195,135 GET cProvincia ; 
      WIDTH 32 ;
      LEN   30 ;
      TITLE "Provincia" ;
      ID 108 ;
      OF oDialog

   @ 245, 17 GET cFechaEnvio ;
      WIDTH 10 ;
      LEN   8 ;
      TITLE "Fecha de envo" ;
      VALID IsFecha( cFechaEnvio ) ;
      ID 109 ;
      OF oDialog

   @ 245,240 GET cPrograma ;
      WIDTH 26 ;
      LEN   30 ;
      TITLE "Programa" ;
      ID 110 ;
      OF oDialog

   @ 275, 17 GETNUM nPesetas ;
      WIDTH 6 ;
      LEN   4 ;
      TITLE "Pts" ;
      ID 111 ;
      OF oDialog

   @ 285, 305 SAY "Marque la casilla si se ha cobrado" OF oDialog

   @ 302, 345 BOX3D SIZE 30, 100 OF oDialog   

   @ 310,357 CHECKBOX aCheck ;
      ITEMS {"Cobrado"} ;
      ID 112 ;
      DEFAULT { if( _FIELD->COBRADO, .T., .F. ) } ;
      OF oDialog

   if lBorrar
      
      @ 335, 90 BUTTON " Borrar " ;
	 SIZE 20, 65 ;
	 EXECUTE lAceptar := .T., oDialog:lEnd := .T. ;
	 OF oDialog

      @ 335,200 BUTTON "Cancelar" ;
	 SIZE 20, 65 ;
	 EXECUTE lAceptar := .F., oDialog:lEnd := .T. ;
	 OF oDialog
   else

      @ 345, 20 BUTTON "Siguiente >>" ;
	 SIZE 20, 80 ;
	 ADJUST 2, 5 ;
	 EXECUTE RNext( oDialog ) ;
	 OF oDialog

      @ 345,120 BUTTON "<< Anterior" ;
	 SIZE 20, 80 ;
	 EXECUTE Back( oDialog ) ;
	 OF oDialog

      @ 345,222 BUTTON "Buscar" ;
	 SIZE 20, 65 ;
	 EXECUTE Bajas( "Buscar cliente", DB_BUSCAR, oDialog ) ;
	 OF oDialog

      @ 345,315 BUTTON "Salvar Reg" ;
	 SIZE 20, 80 ;
	 EXECUTE Save( nCodiClient, ;
		       nPesetas, ;
		       cEmpresa, ;
		       cNombre, ;
		       cApellidos, ;
		       cDireccion, ;
		       cPoblacion, ; 
		       cCP, ;
		       cProvincia, ;
		       cFechaEnvio, ;
		       cPrograma, ;
		       aCheck ) ;
	 OF oDialog

      @ 345,420 BUTTON "Aceptar" ;
	 SIZE 20, 65 ;
	 EXECUTE oDialog:lEnd := .T. ;
	 OF oDialog

   endif
      
   ACTIVATE oDialog

return( lAceptar )

/* ==== FUNCION ESTATICA RNext()
 *      Avanza un registro
 */
STATIC FUNCTION RNext( oDialog )

   DbSkip(1)
   if Eof()
      DbSkip(-1)
      MESSAGEBOX "Ultimo registro"
   else
      NewReg( oDialog )
   endif

return( nil )

/* ==== FUNCION ESTATICA Back()
 *      Retrocede un registro
 */
STATIC FUNCTION Back( oDialog )

   DbSkip(-1)
   if Bof()
      MESSAGEBOX "Primer registro"
   else
      NewReg( oDialog )
   endif

return(nil)

/* ==== FUNCION ESTATICA NewReg()
 *      Cambia los datos de la caja de dilogo con los del nuevo 
 *      registro
 */
STATIC FUNCTION NewReg( oDialog )

   REDEFINE oDialog GETNUM ID 101 WITH Val( _FIELD->CODICLIENT )
   REDEFINE oDialog GET    ID 102 WITH Alltrim( _FIELD->EMPRESA )
   REDEFINE oDialog GET    ID 103 WITH Alltrim( _FIELD->NOMBRE )
   REDEFINE oDialog GET    ID 104 WITH Alltrim( _FIELD->APELLIDOS )
   REDEFINE oDialog GET    ID 105 WITH Alltrim( _FIELD->DIRECCION )
   REDEFINE oDialog GET    ID 106 WITH Alltrim( _FIELD->POBLACION )
   REDEFINE oDialog GET    ID 107 WITH Alltrim( _FIELD->CP )
   REDEFINE oDialog GET    ID 108 WITH Alltrim( _FIELD->PROVINCIA )
   REDEFINE oDialog GET    ID 109 WITH Upper( DToC( _FIELD->FECHAENVIO ) )
   REDEFINE oDialog GET    ID 110 WITH Alltrim( _FIELD->PROGRAMA ) 
   REDEFINE oDialog GETNUM ID 111 WITH _FIELD->PTS 

   REDEFINE oDialog CHECKBOX ID 112 WITH { if( _FIELD->COBRADO, .t., .f. ) }
      
return( nil )

/* ==== FUNCION ESTATICA Save()
 *      Graba el registro actual
 */
STATIC FUNCTION Save( nCodiClient, ;
		      nPesetas, ;
		      cEmpresa, ;
		      cNombre, ;
		      cApellidos, ;
		      cDireccion, ;
		      cPoblacion, ; 
		      cCP, ;
		      cProvincia, ;
		      cFechaEnvio, ;
		      cPrograma, ;
		      aCheck ) 
      
   REPLACE CODICLIENT WITH PadL( nCodiClient, 5, "0" )
   REPLACE EMPRESA    WITH cEmpresa
   REPLACE NOMBRE     WITH cNombre
   REPLACE APELLIDOS  WITH cApellidos
   REPLACE DIRECCION  WITH cDireccion
   REPLACE POBLACION  WITH cPoblacion
   REPLACE CP         WITH PadL( cCP, 5, "0" )
   REPLACE PROVINCIA  WITH cProvincia
   REPLACE FECHAENVIO WITH CToD( cFechaEnvio )
   REPLACE PROGRAMA   WITH cPrograma
   REPLACE PTS        WITH nPesetas
   REPLACE COBRADO    WITH aCheck[ 1 ]

   MESSAGEBOX "Registro salvado"

return( nil )

/* ==== FUNCION ESTATICA Info()
 *      Visualiza informacin de la base de datos
 */
STATIC FUNCTION Info()

   LOCAL nReg := Recno()

   MESSAGEBOX "Nmero de clientes: " + AllTrim( Str( LastRec() ) ) + ;
	   ";;Pts. Recaudadas: " + Recauda() + ;
	   ";;Clientes sin pagar: " + SinPagar()

   DbGoTo( nReg )
	  
return( nil )    

/* ==== FUNCION ESTATICA Recauda()
 *      Calcula las pesetas recaudadas
 */
STATIC FUNCTION Recauda()

   LOCAL nPesetas := 0
   
   DbEval( { || nPesetas += _FIELD->PTS }, { || _FIELD->COBRADO } )
   
return( StrTran( Transform( nPesetas, "9,999,999" ), ",", "." ) )

/* ==== FUNCION ESTATICA SinPagar()
 *      Determina cuntos clientes existen sin pagar
 */
STATIC FUNCTION SinPagar()

   LOCAL nCont := 0
   
   DbEval( { || nCont++ }, { || !_FIELD->COBRADO } )
   
return( AllTrim( Str( nCont ) ) )

/* ==== FUNCTION ESTATICA IsNumeric()
 *      Devuelte .T. si la cadena son nmeros o .F. sino.
 */
STATIC FUNCTION IsNumeric( cString )

   LOCAL nCont, ;
	 nASCII
   LOCAL lNumeric := .T.

   for nCont := 1 to Len( cString )
      nASCII := Asc( SubStr( cString, nCont, 1 ) )
      if nASCII < 48 .or. nASCII > 57
	 lNumeric := .F.
	 MESSAGEBOX "No es un valor numrico   "
	 exit
      endif
   next
	 
return( lNumeric )

/* ==== FUNCTION ESTATICA IsFecha()
 *      Devuelte .T. si la cadena es una fecha correcta o .F. sino.
 */
STATIC FUNCTION IsFecha( cString )

   LOCAL lFecha := .F.
   
   if !Empty( CToD( cString ) )
      lFecha := .T.
   else
      MESSAGEBOX "Fecha no vlida    "
   endif
	 
return( lFecha )
