/*
 *      Mdulo............: OGLDEMO.PRG
 *      Utilidad..........: Diccionario informtico v1.0
 *
 *      Fecha de creacin.: 30-03-1995
 *      Ultima revisin...: 06-04-1996
 *
 *      Copyright (c) 1995, 96 por Gabriel Muoz Mrquez
 *      Todos los derechos reservados
 */

#include "ogl.ch"

#define LIST  1
#define MEMO  4
#define BOTON 8

STATIC nRegistros := 0

FUNCTION Main()

   // Si no existe el archivo ndice lo creamos
   if !File( "OGLDEMO.NTX" )
      DBUseArea( .F., "DBFNTX", "OGLDEMO",, .F. )
      DBCreateIndex( "OGLDEMO", "Upper( TERMINO )", { || Upper( _FIELD->TERMINO ) } )
      DBCloseArea()
   endif
   
   DBUseArea( .F., "DBFNTX", "OGLDEMO",, .F. )
   DBSetIndex( "OGLDEMO" )
   DBEval( { || nRegistros++ } )        // Calcular nmero de registros

   INIT GRAPHICS PATH "C:\CLIPPER5\OGL"

   DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) <= "9" .and. ;
		     SubStr( _FIELD->TERMINO, 1, 1 ) >= "0" } )
   Screen( GetTerminos() )

   CLOSE GRAPHICS

   DBCloseArea()

return( nil )

/* ==== Define el objeto Screen y lo activa
 *
 *      Parmetros: aTerminos -> Array con las opciones iniciales para
 *                               el ListBox.
 */
FUNCTION Screen( aTerminos )

   LOCAL oScreen
   LOCAL nBoton := 1

   DEFINE SCREEN oScreen ;
      PCX "SCR" ;
      IN FILEDAT "OGLDEMO.DAT" 

   @  215, 21 LISTBOX aTerminos ;
      SIZE 10, 250 ;
      BLOCK   { | nPos, cTermino | ;
	 DBSeek( Upper( cTermino ) ), ;
	 oScreen:aControls[ MEMO ]:cMemo    := _FIELD->DEFINICION, ;
	 oScreen:aControls[ MEMO ]:nCurrent := 1, ;
	 oScreen:aControls[ MEMO ]:Show( .F. ) } ;
      COLOR ,"g/w+" ; 
      NO3DEFFECT ;
      OF oScreen

   @ 160, 316 LISTMEMO _FIELD->DEFINICION ;
      SIZE 17, 285 ;
      COLOR "b","n" ;
      NOBORDER ;
      WITHSHADOW ;
      SAVEBACKGROUND ;
      NO3DEFFECT ;
      OF oScreen

   @ 6, 470 VIRTUAL BUTTON ;
      SIZE 30, 99 ;
      EXECUTE oScreen:lEnd := .T. ;
      OF oScreen

   @ 55, 470 VIRTUAL BUTTON ;
      SIZE 30, 99 ;
      EXECUTE Info() ;
      OF oScreen

   // Nmeros
   @ 129, 29 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      PUSHED ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 1, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) <= "9" .and. ;
			   SubStr( _FIELD->TERMINO, 1, 1 ) >= "0" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // A
   @ 129, 57 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 2, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Aa" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // B
   @ 129, 85 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 3, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Bb" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // C
   @ 129, 113 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 4, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Cc" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // D
   @ 129, 141 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 5, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Dd" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen
   
   // E
   @ 129, 169 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 6, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Ee" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // F
   @ 129, 197 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 7, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Ff" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // G
   @ 129, 225 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 8, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Gg" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // H
   @ 129, 253 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 9, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Hh" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // I
   @ 153, 29 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 10, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Ii" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // J
   @ 153, 57 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 11, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Jj" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // K
   @ 153, 85 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 12, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Kk" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // L
   @ 153, 113 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 13, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Ll" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // M
   @ 153, 141 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 14, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Mm" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // N
   @ 153, 169 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 15, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Nn" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // O
   @ 153, 197 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 16, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Oo" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // P
   @ 153, 225 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 17, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Pp" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // Q
   @ 153, 253 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 18, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Qq" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // R
   @ 177, 29 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 19, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Rr" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // S
   @ 177, 57 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 20, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Ss" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // T
   @ 177, 85 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 21, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Tt" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // U
   @ 177, 113 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 22, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Uu" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // V
   @ 177, 141 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 23, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Vv" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // W
   @ 177, 169 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 24, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Ww" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // X
   @ 177, 197 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 25, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Xx" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // Y
   @ 177, 225 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 26, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Yy" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

   // Z
   @ 177, 253 VIRTUAL BUTTON ;
      SIZE 19, 22 ;
      ONECLICK ;
      EXECUTE ;
	 oScreen:aControls[ BOTON + nBoton ]:Free(), ;
	 nBoton := 27, ;
	 DBSetFilter( { || SubStr( _FIELD->TERMINO, 1, 1 ) $ "Zz" } ), ;
	 ShowList( oScreen ) ;
      OF oScreen

return( ACTIVATE oScreen )

STATIC FUNCTION Info()

   LOCAL oDialog
   LOCAL cOldFont

   DEFINE DIALOG oDialog ;
      FROM 100,300 TO 400,600 ;
      EXECUTE ;
	 MSOff(), ;
	 cOldFont := SetFont( OGLDir() + "OGL000.DAT", "HELV" ), ;
	 GTextShadow( oDialog:nTop + 50, oDialog:nLeft + 80, "Diccionario Informtico", 2, 15 ), ;
	 GTextShadow( oDialog:nTop + 65, oDialog:nLeft + 80, "     versin 1.0", 2, 15 ), ;
	 SetFont( OGLDir() + "OGL000.DAT", "TIMES" ), ;
	 GText( oDialog:nTop + 100, oDialog:nLeft + 40, "Programacin: Gabriel Muoz", 0 ), ;
	 GText( oDialog:nTop + 116, oDialog:nLeft + 40, "Grficos",0 ), ;
	 GText( oDialog:nTop + 116, oDialog:nLeft + 123, ": Juan Luis Fernndez", 0 ), ;
	 GText( oDialog:nTop + 150, oDialog:nLeft + 20, "  Programa realizado con la librera", 12 ), ;
	 GText( oDialog:nTop + 166, oDialog:nLeft + 20, " orientada al objeto para CA-Clipper 5.X", 12 ), ;
	 GTextShadow( oDialog:nTop + 182, oDialog:nLeft + 20, "        Object Graph Library.", 12, 15 ), ;
	 GText( oDialog:nTop + 220, oDialog:nLeft + 50, "Palabras en el diccionario: " + Alltrim( Str( nRegistros ) ), 0 ), ;
	 SetFont( OGLDir() + "OGL000.DAT", cOldFont ), ;
	 MSOn() ;
      TITLE "Informacin" ;
      COLOR ,"w+/r+"

   @ 235, 120 BUTTON "Aceptar" ;
      SIZE 20, 65 ;
      EXECUTE oDialog:lEnd := .T. ;
      OF oDialog

return( ACTIVATE oDialog )

/* ==== Devuelve, en un array, cada uno de los trminos seleccionados 
 *      mediante un filtro previo.
 */
STATIC FUNCTION GetTerminos()

   LOCAL aArray := {}

   DBEval( { || AAdd( aArray, Alltrim( _FIELD->TERMINO ) ) } ) 

return( aArray )

/* ==== Muestra la lista de trminos en el ListBox
 *      
 *      Parmetros: oScreen -> Objeto screen.
 */
STATIC FUNCTION ShowList( oScreen )

   oScreen:aControls[ LIST ]:aOpcs    := AClone( GetTerminos() )
   oScreen:aControls[ LIST ]:nCurrent := 1
   oScreen:aControls[ LIST ]:nLight   := 0
   oScreen:aControls[ LIST ]:Show( .f. ) 

return( nil )
