/*
 *      Mdulo............: TUTOR.PRG
 *      Utilidad..........: Muestra de todos los objetos de los dilogos
 *
 *      Ultima revisin...: 04-03-1996
 *
 *      Copyright (c) 1995, 96 por Gabriel Muoz Mrquez
 *      Todos los derechos reservados
 */

#include "ogl.ch"

#define CRLF CHR( 13 ) + CHR( 10 )

FUNCTION Main()

   LOCAL oDialog
   LOCAL aCheck
   LOCAL cPassW, ;
         cNombre
   LOCAL nCombo, ;
         nRadio, ;
         nGetNum

   // Siempre primero inicializar grficos 
   INIT GRAPHICS PATH "C:\CLIPPER5\OGL"

   // Poner el fondo de azul
   GBox( 0, 0, 479, 639, ColorToN( "B" ) )
   SetFont( OGLDir() + "OGL000.DAT", "BOLD" )
   GTextShadow( 5, 5, "Tutor", ColorToN( "GR+" ) )
   
   // Definir la caja de dilogo
   DEFINE DIALOG oDialog ;
      FROM 60, 20 TO 400, 600 ;        // Coordenadas
      TITLE "Object Graph Library v1.0 - Interfaz grfico para CA-Clipper!"

   // Marco tridimensional
   @ 25, 10 BOX3D SIZE 130, 180 ;
      TITLE "CheckBox y RadioBox" ;  // Ttulo del marco
      COLOR "GR+" ;
      OF oDialog                     // Vincular a oDialog

   // CheckBox
   @ 30, 20 CHECKBOX aCheck ;
      ITEMS { "Uno", "Dos", "Tres", "Cuatro", "Cinco", "Seis", "Siete" };
      ID 1 ;
      DEFAULT { .t., .t., .t., .t., .f., .t.,.t. } ;  // Valores por defecto
      BLOCK { | aCheck, nItem | ChangeCheck( aCheck, nItem, oDialog ) } ;
      OF oDialog

   // RadioBox
   @ 30, 120 RADIOBOX nRadio ;
      ITEMS { "Uno", "Dos", "Tres", "Cuatro", "Cinco", "Seis", "Siete" };
      ID 2 ;
      BLOCK { | nRadio, nOldItem | ChangeRadio( nRadio, nOldItem, oDialog ) } ;
      DEFAULT 5 ;      // Valor por defecto
      OF oDialog

   @ 25, 220 BOX3D SIZE 140, 350 ;
      TITLE "ListBox y ListMemo" ;
      COLOR "GR+" ;
      OF oDialog

   @ 27, 230 LISTBOX {"Borland C++ v3.1", "CA-Clipper 5.2", "Visual Objects", ;
      "Lotus 1-2-3", "Microsoft Word 6.0", "Windows 95", "Pentium" } ;
      SIZE 7, 140 ;
      BLOCK { | nOpc, cOpc | MESSAGEBOX cOpc TITLE "Seleccin" NOCENTERTEXT } ;
      OF oDialog

   @ 32, 400 LISTMEMO "Esto es una prueba de" + CRLF + ;
                      "visualizacin de un"   + CRLF + ;
                      "campo memo" + CRLF + CRLF + CRLF + CRLF + CRLF + CRLF + ;
                      "Siguiente pgina" ;
      SIZE 8, 140 ;
      OF oDialog

   @ 180, 10 BOX3D SIZE 120, 180 ;
      TITLE "Button" ;
      COLOR "GR+" ;
      OF oDialog

   @ 190,70 BUTTON "Tone()" EXECUTE Tone( 300, 1 ), Rede( oDialog ) ;
      OF oDialog
      
   @ 220,60 BUTTON "MessageBox"  ;
      SIZE 40, 80 ;
      EXECUTE MESSAGEBOX "El MessageBox" NOCENTERTEXT ;
      OF oDialog

   @ 180, 220 BOX3D SIZE 120, 350 ;
      TITLE "Get" ;
      COLOR "GR+" ;
      OF oDialog

   @ 200, 245 GETNUM nGetNum ;
      WIDTH 5 ;
      PROMPT "Edad    " ;
      RANGE 0, 4 ;
      OF oDialog

   @ 200, 420 COMBOBOX nCombo ;
      ITEMS { "Opcin1", "Opcin2", "Opcin3", "Opcin4" } ;
      HEIGHT 4 ;
      OF oDialog
   
   @ 230, 245 GET cPassW ;
      WIDTH 20 ;
      LEN 20 ;
      PROMPT "PassWord" ;
      WITH PASSWORD ;
      KEYS { | nTecla | if( nTecla == 13, oDialog:lEnd := .t., ) } ;
      OF oDialog
   
   @ 260, 245 GET cNombre ;
      WIDTH 15 ;
      LEN 50 ;
      ID 3 ;
      VALID NoEmpty( cNombre ) ;
      PROMPT "Nombre  " ;
      OF oDialog

   ACTIVATE oDialog

   CLOSE GRAPHICS

return( nil )

// -------------------------------------------------------------------- //

STATIC FUNCTION NoEmpty( cVar )

   if Empty( cVar )
      Tone( 400, 1 )
      MESSAGEBOX "Este campo no puede estar vaco"
      return( .F. )
   endif

return( .T. )

// -------------------------------------------------------------------- //

STATIC FUNCTION Rede( oDialog )
   
   REDEFINE oDialog CHECKBOX ID 1 WITH { .F., .F., .F., .F., .F., .F., .T. }
   REDEFINE oDialog RADIOBOX ID 2 WITH 2
   REDEFINE oDialog GET      ID 3 WITH "Bartolo"

RETURN( nil )

// -------------------------------------------------------------------- //

STATIC FUNCTION ChangeCheck( aCheck, nItem, oDialog )

   // Si el primer tem del CheckBox se activa, se activarn todos

   if nItem == 1 .and. aCheck[ 1 ]
      REDEFINE oDialog CHECKBOX ID 1 WITH { .T., .T., .T., .T., .T., .T., .T. }
   endif

return( nil )

// -------------------------------------------------------------------- //

STATIC FUNCTION ChangeRadio( nRadio, nOldRadio, oDialog )

   // Si se selecciona la primera opcin del Radiobox cuando estaba
   // activada la nmero 7, se seleccionar automticamente la nmero 4.
   //
   //  Bonito juego de palabras !

   if nRadio == 1 .and. nOldRadio == 7
      REDEFINE oDialog RADIOBOX ID 2 WITH 4
   endif

return( nil )

