/*
 *      OGL.CH 
 *      Definiciones de lenguaje Clipper para Object Graph Library v1.0
 *
 *      Copyright (c) 1996 por Gabriel Muoz Mrquez
 */

#ifndef _OGL_CH
   #define _OGL_CH

   #xcommand DEFAULT <Var1> := <Dato1> [, <VarN> := <DatoN> ] => ;
      <Var1> := iif(<Var1> == NIL, <Dato1>, <Var1>) ;;
    [ <VarN> := iif(<VarN> == NIL, <DatoN>, <VarN>); ]

   #xtranslate INITGRAPHICS => INIT GRAPHICS

   #xcommand INIT GRAPHICS ;
		[ PATH <cDirectory> ] ;
		[ <lNoWarnings: NOWARNING, NOWARNINGS> ] ;
      => ;
	 InitGraph( <cDirectory>, <.lNoWarnings.> )
						   
   #xcommand DEFINE SCREEN <oScr> PCX <cFilePCX> ;
	       IN FILEDAT <cFileDAT> ;
	       [ <pal: NOPALETTE, NO PALETTE> ] ; 
	       [ <fad: NOFADE, NO FADE> ] ;
	=> ;
	   <oScr> := TScreen( <cFileDAT>, <cFilePCX>, <.pal.>, <.fad.> )
      
   // Colores = cColorBox, cClrTitle
   #xcommand DEFINE DIALOG <oDlg> ;
	       FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ;
	       [ EXECUTE <xAccion> [, <xAccionN> ] ] ;
	       [ TITLE <cTitulo> ] ;
	       [ <clr: COLOR, COLORS> <cColors,...>  ] ;
	=> ;
	   <oDlg> := TDialog( <nTop>, <nLeft>, <nBottom>, <nRight>, ;
	      <cTitulo>, { || nil [,<xAccion>] [,<xAccionN> ] }, <cColors> )
      
   #xcommand @<nRow>, <nCol> BUTTON [ <oBtn> LABEL ] <cLabel>;
	       [ SIZE <nAlto>, <nAncho> ] ;
	       [ ADJUST <nRowAdj>, <nColAdj> ] ;
	       [ FONT <cFont> ] ;
	       [ <clr: COLOR, COLORS> <cColor> ] ;
	       [ EXECUTE <xAccion> [, <xAccionN> ] ] ;
	       [ <oBlock:BLOCK> <bBlock> ] ;
	       [ <wait: NOWAIT, NO WAIT> ] ;
	       [ <lPush: PUSHED> ] ;
	       [ <lOne: ONECLICK, ONE CLICK> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oBtn> := ] TButton( <nRow>, <nCol>, <nAlto>, <nAncho>, <cLabel>,; 
	    if( <.oBlock.>, <{bBlock}>, { || nil [,<xAccion>] [,<xAccionN>] } ), ;
	    <oObjeto>, <.wait.>, <.lPush.>, <.lOne.>, <nRowAdj>, <nColAdj>, ;
	    <cColor>, <cFont> )
			   
   #xcommand @<nRow>, <nCol> VIRTUAL BUTTON [ <oBtn> ] ;
	       [ SIZE <nAlto>, <nAncho> ] ;
	       [ EXECUTE <xAccion> [, <xAccionN> ] ] ;
	       [ <oBlock:BLOCK> <bBlock> ] ;
	       [ <lNoDraw: NODRAW, NO DRAW> ] ;
	       [ <wait: NOWAIT, NO WAIT> ] ;
	       [ <lPush: PUSHED> ] ;
	       [ <lOne: ONECLICK, ONE CLICK> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oBtn> := ] TVirButton( <nRow>, <nCol>, <nAlto>, <nAncho>, ,; 
	    , if( <.oBlock.>, <{bBlock}>, { || nil [,<xAccion>] [,<xAccionN>] } ), ;
	    <oObjeto>, <.wait.>, <.lNoDraw.>, <.lPush.>, <.lOne.> )

   // Colores = cColor, cClrBar, cClrShadow, cClrBorde
   #xcommand @<nRow>, <nCol> LISTBOX [ <oLst> ITEMS ] <aOpcs> ;
	       [ SIZE <nItemsVisibles>, <nAncho> ] ;
	       [ EXECUTE <xAccion> [, <xAccionN> ] ] ;
	       [ ID <nID> ] ;
	       [ <oBlock:BLOCK> <bBlock> ] ;
	       [ <clr: COLOR, COLORS> <cColors,...> ] ;
	       [ <lShadow: WITHSHADOW, WITH SHADOW> ] ;
	       [ <l3D: NO3DEFFECT, NO 3D EFFECT> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
	=> ;
	   [ <oLst> := ] TListBox( <nRow>, <nCol>, <nItemsVisibles>, <nAncho>,;
	      <aOpcs>, if( <.oBlock.>, <{bBlock}>, { || nil [,<xAccion>] [,<xAccionN>] } ),; 
	      <oObjeto>, <.lShadow.>, <.l3D.>, <nID>, <cColors> )

   // Colores = cColor, cClrShadow, cClrBorde
   #xcommand @<nRow>, <nCol> LISTMEMO [ <oMemo> MEMO ] <cMemo> ;
	       [ SIZE <nLineasVisibles>, <nAncho> ] ;
	       [ <lNoBorde: NOBORDER, NO BORDER> ] ;
	       [ <lBkSave: SAVEBACKGROUND, SAVE BACKGROUND> ];
	       [ <lShadow: WITHSHADOW, WITH SHADOW> ] ;
	       [ <l3D: NO3DEFFECT, NO 3D EFFECT> ] ;
	       [ <clr: COLOR, COLORS> <cColors,...> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oMemo> := ] TListMemo( <nRow>, <nCol>, <nLineasVisibles>, <nAncho>,  ;
	    <cMemo>, <oObjeto>, <.lNoBorde.>, <.lBkSave.>, <.lShadow.>, ;
	    <.l3D.>, <cColors> )

   // Colores = cColorText, cColorRombos
   #xcommand @<nTop>, <nLeft> RADIOBOX [ <oRadio> VAR ] <nVar> ;
	       ITEMS <aItems> ;
	       [ DEFAULT <nDefault> ] ;
	       [ ID <nID> ] ;
	       [ BLOCK <bBlock> ] ;
	       [ <clr: COLOR, COLORS> <cColor,...> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oRadio> := ] TRadioBox( <nTop>, <nLeft>, <aItems>, <nDefault>, ;
	    <oObjeto>, [ { | x | <nVar> := x } ], <nID>, <bBlock>, <cColor> )

   // Colores = cColorText, cColorBoxes
   #xcommand @<nTop>, <nLeft> CHECKBOX [ <oCheck> VAR ] <aVar> ;
	       ITEMS <aItems> ;
	       [ DEFAULT <aDefault> ] ;
	       [ ID <nID> ] ;
	       [ BLOCK <bBlock> ] ;
	       [ <clr: COLOR, COLORS> <cColor,...> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oCheck> := ] TCheckBox( <nTop>, <nLeft>, <aItems>, <aDefault>, ;
	    <oObjeto>, [ { | x | <aVar> := x } ], <nID>, <bBlock>, <cColor> )

   #xcommand @<nTop>, <nLeft> BOX3D [ <oBox3D> ] SIZE <nAlto>, <nAncho> ;
	       [ TITLE <cTitle> ] ;
	       [ <clr: COLOR, COLORS> <cColor> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;  
      => ;
	 [ <oBox3D> := ] TBox3d( <nTop>, <nLeft>, <nAlto>, <nAncho>, <cTitle>, <oObjeto>, <cColor> )

   #xcommand @<nTop>, <nLeft> WIN3D [ <oWin3D> ] SIZE <nAlto>, <nAncho> ;
	       [ TITLE <cTitle> ] ;
	       [ <clr: COLOR, COLORS> <cColor> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;  
      => ;
	 [ <oWin3D> := ] TWin3d( <nTop>, <nLeft>, <nAlto>, <nAncho>, <cTitle>, <oObjeto>, <cColor> )

   #xcommand @<nRow>, <nCol> SAY [ <oSay> <txt: TEXT, MESSAGE, PROMPT> ] <cText> ;
	       [ FONT <cFont> ] ;
	       [ <clr: COLOR, COLORS> <cColor> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oSay> := ] TSay( <nRow>, <nCol>, <cText>, <cFont>, <oObjeto>, <cColor> )

   // Las coordenadas no se deben indicar en pixels sino en filas y columnas
   // de 80x30.
   #xcommand @<nRow>, <nCol> COMBOBOX [ <oCombo> VAR ] <nVar> ;
	       ITEMS <aItems> ;
	       [ HEIGHT <nItemsVisibles> ] ;
	       [ <label: LABEL, PROMPT, TITLE> <cLabel> ] ;
	       [ DEFAULT <nDefault> ] ;
	       [ BLOCK <bBlock> ] ;
	       [ <clr: COLOR, COLORS> <cColor,...> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oCombo> := ] TComboBox( <nRow>, <nCol>, <aItems>, <nDefault>, ;
	    <nItemsVisibles>, <cLabel>, <bBlock>, [ { | x | <nVar> := x } ], <oObjeto>, <cColor> )

   // Las coordenadas no se deben indicar en pixels sino en filas y columnas
   // de 80x30.
   #xcommand @<nRow>, <nCol> GET [ <oGet> VAR ] <cVar> ;
	       [ <label: LABEL, PROMPT, TITLE> <cLabel> ] ;   
	       [ WIDTH <nWidth> ] ;
	       [ LEN <nLen> ] ;
	       [ WHEN <xWhen> ] ;
	       [ VALID <xValid> ] ;
	       [ KEYS <bKeys> ] ;
	       [ <lPass: WITHPASSWORD, WITH PASSWORD> ] ;
	       [ ID <nID> ] ;
	       [ <clr: COLOR, COLORS> <cColor,...> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oGet> := ] TGet( <nRow>, <nCol>, <cVar>, <cLabel>, <nWidth>, <nLen>, ;
	    <{xWhen}>, <{xValid}>, <bKeys>, <oObjeto>, [ { | x | <cVar> := x } ], <.lPass.>, ;
	    <nID>, <cColor> )

   // Las coordenadas no se deben indicar en pixels sino en filas y columnas
   // de 80x30.
   #xcommand @<nRow>, <nCol> GETNUM [ <oGet> VAR ] <nVar> ;
	       [ <label: LABEL, PROMPT, TITLE> <cLabel> ] ;   
	       [ WIDTH <nWidth> ] ;
	       [ LEN <nLen> ] ;
	       [ WHEN <xWhen> ] ;
	       [ VALID <xValid> ] ;
	       [ RANGE <nInf>, <nSup> ] ;
	       [ BLOCK <bBlock> ] ;
	       [ ID <nID> ] ;
	       [ <clr: COLOR, COLORS> <cColor,...> ] ;
	       [ <obj: OF DIALOG, OF SCREEN, OF> <oObjeto> ] ;
      => ;
	 [ <oGet> := ] TGetNum( <nRow>, <nCol>, <nVar>, <cLabel>, <nWidth>, <nLen>, ;
	    <{xWhen}>, <{xValid}>, <oObjeto>, [ { | x | <nVar> := Val( x ) } ],, ;
	    <nInf>, <nSup>, <bBlock>, <nID>, <cColor> )

   #xcommand REDEFINE <oObjeto> GET ID <nID> WITH <cValor> ;
      => ;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:Assign( <cValor> )

   #xcommand REDEFINE <oObjeto> GETNUM ID <nID> WITH <nValor> ;
      => ;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:Assign( Str( <nValor> ) )
	 
   #xcommand REDEFINE <oObjeto> CHECKBOX ID <nID> WITH <aArray> ;
      => ;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:alCheck := AClone( <aArray> ) ;;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:Show()

   #xcommand REDEFINE <oObjeto> RADIOBOX ID <nID> WITH <nValor> ;
      => ;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:nItem    := <nValor> ;;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:nDefecto := <nValor> - 1 ;;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:Show()
	 
   #xcommand REDEFINE <oObjeto> LISTBOX ID <nID> WITH <aArray> ;
      => ;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:aOpcs    := AClone( <aArray> ) ;;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:nCurrent := 1 ;;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:nLight   := 0 ;;
	 <oObjeto>:aControls\[ ScanID( <nID>, <oObjeto> ) \]:Show( .f. ) 
   
   // Colores = cClrBox, cClrTitle, cClrButton
   #xtranslate MESSAGEBOX <cMensaje> ;
	       [ VAR <lVar> ] ;
	       [ TITLE <cTitle> ] ;
	       [ HEIGHT <nAlto> ] ; 
	       [ WIDTH <nAncho> ] ;
	       [ <BtnOK: BTN_OK> ] ;
	       [ <BtnCANCEL: BTN_OKCANCEL> ] ;
	       [ <lCent: NOCENTERTEXT, NO CENTER TEXT> ] ;
	       [ FONT <cFont> ] ;
	       [ <clr: COLOR, COLORS> <cColors,...> ] ;
      => ;
	 MsgBox( <nAlto>, <nAncho>, <cMensaje>, if( <.BtnOK.>, .T., ;
	     if( <.BtnCANCEL.>, .F., ) ), <cTitle>, <cFont>, <.lCent.>, ; 
	     [ { | x | <lVar> := x } ], <cColors> )
	     
   #xcommand DEFINE PULLDOWN <oMenu> ;
	    [ <nm: NAME, TITLE> <cNameAppl> ] ;
	    [ BACKGROUND <bBlock> ] ;
	    [ WELCOME <bWelcome> ] ;
	    [ <clr: COLOR, COLORS> <cColors,...> ] ;
      => ; 
	 LOCAL <oMenu>, xOGLM ;;
	 <oMenu> := TMenu( <cNameAppl>, <bBlock>, <bWelcome>, <cColors> ) ;;
	 xOGLM := <oMenu> ;;
       
   #xcommand MENU <cMenu> ;
	    [ MESSAGE <cMensaje> ] ;
      => ;
	 xOGLM:AddMenu( TMenuBox( <cMenu>, <cMensaje>, xOGLM ) )
      
   #xcommand MENUITEM <cItem> ;
	    [ MESSAGE <cMensaje> ] ;  
	    [ EXECUTE <Accion> [, <AccionN> ] ] ;
	    [ <oBlock: BLOCK> <bBlock> ] ;
	    [ SHORTKEY <nTecla> ] ;
	    [ <lDisabled: DISABLED> ] ;
      => ;
	 xOGLM:aControls\[ Len( xOGLM:aControls ) \]:AddItem( TMenuItem( <cItem>, ;
	    <cMensaje>, if( <.oBlock.>, <{bBlock}>, { || nil [, <Accion> ] [, <AccionN> ] } ), ; 
	    <.lDisabled.>, <nTecla>, xOGLM ) )

   #xcommand MENUITEM SEPARATOR => MENUITEM ""

   #xcommand ENDMENU => xOGLM:aControls\[ Len( xOGLM:aControls ) \]:Config()

   #xcommand ENDPULLDOWN => 

   #xtranslate CLOSEGRAPHICS => CLOSE GRAPHICS

   #xcommand CLOSE GRAPHICS ;
	       [ <fad: NOFADE, NO FADE> ] ;
      => ;
	 CloseGraph( <.fad.> )

   #xtranslate ACTIVATE <oObj> ;
      => ;
	 <oObj>:Run()
	 
   // Valores de retorno de la funcin GetDrive
   #define D_PREPARADA   0
   #define D_NOPREPARADA 1
   #define D_PROTEGIDO   2
   #define D_DESCONOCIDO 3

#endif
